# Redmine - project management software
# Copyright (C) 2006-2013  Jean-Philippe Lang
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
class UsersController < ApplicationController
  layout :setting_layout
  #Added by young
  menu_item :activity
  menu_item :user_information, :only => :info
  menu_item :user_course, :only => :user_courses
  menu_item :user_homework, :only => :user_homeworks
  menu_item :user_project, :only => [:user_projects, :watch_projects]
  menu_item :requirement_focus, :only => :watch_bids
  menu_item :requirement_focus, :only => :watch_contests   
  menu_item :user_newfeedback, :only => :user_newfeedback
  
 
  #Ended by young

 
  before_filter :require_admin, :except => [:show, :index, :search, :tag_save, :user_projects, :user_newfeedback, :user_comments, :watch_bids, :watch_contests, :info, 
    :user_watchlist, :user_fanslist,:update, :user_courses, :user_homeworks, :watch_projects, :show_score, :topic_score_index, :project_score_index,
    :activity_score_index, :influence_score_index, :score_index] 
  #edit has been deleted by huang, 2013-9-23
  before_filter :find_user, :only => [:user_fanslist, :user_watchlist, :show, :edit, :update, :destroy, :edit_membership, :user_courses, 
                                  :user_homeworks, :destroy_membership, :user_activities, :user_projects, :user_newfeedback, :user_comments, 
                                  :watch_bids, :watch_contests, :info, :watch_projects, :show_score, :topic_score_index, :project_score_index, 
                                  :activity_score_index, :influence_score_index, :score_index]
  accept_api_auth :index, :show, :create, :update, :destroy,:tag_save
  
  #william
  before_filter :require_login, :only => :tag_save


  helper :sort
  include SortHelper
  helper :custom_fields
  include CustomFieldsHelper
  include AvatarHelper

  # added by liuping 关注 

  helper :watchers
  helper :activities

  ### added by william
  include ActsAsTaggableOn::TagsHelper

  #  fq
  helper :words
  #added by young
  def user_projects
    
    if User.current.admin?
      @memberships = @user.memberships.all
    else
      cond = Project.visible_condition(User.current) + "AND projects.project_type <> 1"
      @memberships = @user.memberships.all(:conditions => cond)
    end
    events = Redmine::Activity::Fetcher.new(User.current, :author => @user).events(nil, nil, :limit => 20)
    @events_by_day = events.group_by(&:event_date)
    @state = 0


  #add by huang
    unless User.current.admin?
      if !@user.active? #|| (@user != User.current  && @memberships.empty? && events.empty?)
        render_404
      return
      end
    end
  #end
  
    respond_to do |format|
      format.html
      format.api
    end
  end

# added by bai
  def show_score
    
  end
# end

  ##added by fq
  def watch_bids
    cond = 'bids.reward_type <> 1'     
    @bids = Bid.watched_by(@user).where('reward_type = ?', 1) # added by huang
    @offset, @limit = api_offset_and_limit({:limit => 10})
    @bid_count = @bids.count
    @bid_pages = Paginator.new @bid_count, @limit, params['page']
    @offset ||= @bid_pages.reverse_offset 
    unless @offset == 0
      @bid = @bids.offset(@offset).limit(@limit).all.reverse
    else
      limit = @bid_count % @limit
      @bid = @bids.offset(@offset).limit(limit).all.reverse
    end
   
    respond_to do |format|
      format.html {
        render :layout => 'base_users'
      }
      format.api
    end
  end
  
#new add by linchun
  def watch_contests    
    @bids = Contest.watched_by(@user) 
    @offset, @limit = api_offset_and_limit({:limit => 10})
    @contest_count = @contests.count
    @contest_pages = Paginator.new @contest_count, @limit, params['page']
    @offset ||= @contest_pages.reverse_offset 
    unless @offset == 0
      @contest = @contests.offset(@offset).limit(@limit).all.reverse
    else
      limit = @bid_count % @limit
      @contest = @contests.offset(@offset).limit(limit).all.reverse
    end
   
    respond_to do |format|
      format.html {
        render :layout => 'base_users'
      }
      format.api
    end
  end

  #  added by fq
  def user_activities
    @watcher = User.watched_by_id(@user)
    events = []
    for user in @watcher
      events << Redmine::Activity::Fetcher.new(User.current, :author => @user).events(nil, nil, :limit => 30)
    end
    
    
    
    @events_by_day = events.group_by(&:event_date)

    unless User.current.admin?
      if !@user.active? || (@user != User.current  && @memberships.empty? && events.empty?)
        render_404
      return
      end
    end

    respond_to do |format|
      format.html
      format.api
    end
  end
  # end
  
  # added by huang
  def user_homeworks                
      @membership = @user.memberships.all(:conditions => Project.visible_condition(User.current))  
      @memberships = []
      @membership.each do |membership|
        if membership.project.project_type == 1
          @memberships << membership 
        end
      end
      @bid = []
      @memberships.each do |membership|
      @bid += membership.project.homeworks
      end
      @bid = @bid.group_by {|bid| bid.courses.first.id}
      unless User.current.admin?
      if !@user.active? 
        render_404
      return
      end 
      end  
  end 
  
  
  include CoursesHelper
  def user_courses   

    unless User.current.admin?
      if !@user.active? #|| (@user != User.current  && @memberships.empty? && events.empty?)
        render_404
      return
      end
    end
  
    membership = @user.memberships.all(:conditions => Project.visible_condition(User.current))
    membership.sort! {|older, newer| newer.created_on <=> older.created_on }
    @memberships = []
    membership.collect { |e| 
      @memberships.push(e) if(e.project.project_type == 1)
    }
    ## 判断课程是否过期 [需封装]
    @memberships_doing = []
    @memberships_done  = []
    now_time = Time.now.year
    @memberships.map { |e|
      end_time = e.project.course_extra.get_time.year
      isDone = course_endTime_timeout?(e.project)
      if isDone
        @memberships_done.push e
      else
        @memberships_doing.push e
      end
    }
    # respond_to do |format|
      # format.html
      # format.api
    # end
  end

# modified by fq
  def user_newfeedback
    @jours = @user.journals_for_messages.where('m_parent_id IS NULL').order('created_on DESC')
    @jours.update_all(:is_readed => true, :status => false)
    
    @limit =  10
    @feedback_count = @jours.count
    @feedback_pages = Paginator.new @feedback_count, @limit, params['page']
    @offset ||= @feedback_pages.offset
    @jour = @jours[@offset, @limit]
    @state = false
  end
 # end

  def user_comments

  end

  #end
  def index
   
    @project_type = params[:project_type]
    role = params[:role]
    
    sort_init 'login', 'asc'
    sort_update %w(login firstname lastname mail admin created_on last_login_on)

    case params[:format]
    when 'xml', 'json'
      @offset, @limit = api_offset_and_limit({:limit => 15})
    else
    @limit = 15#per_page_option
    end

    @status = params[:status] || 1
    has = {
      "show_changesets" => true
    }
    # @count = Redmine::Activity::Fetcher.new(User.current, :author => @user).scope_select {|t| !has["show_#{t}"].nil?}.events(nil, nil).count
    
    scope = UserStatus.visible
    case role
    when 'teacher'
      scope = UserStatus.teacher
    when 'student'
      scope = UserStatus.student
    else
      
    end
    
    scope = scope.in_group(params[:group_id]) if params[:group_id].present?
    # scope.each do |user|
      # UserStatus.create(:changesets_count => user.changesets.count, :watchers_count => user.watcher_users.count, :user_id => user.id)
    # end
    @user_count = scope.count
    @user_pages = Paginator.new @user_count, @limit, params['page']
    #@offset ||= @user_pages.offset
    #@users =  scope.order(sort_clause).limit(@limit).offset(@offset).all
    @user_base_tag = params[:id] ? 'base_users':'base'
      if params[:user_sort_type].present?
      case params[:user_sort_type]
      when '0'
        @offset ||= @user_pages.reverse_offset
        unless @offset == 0
          @users_statuses = scope.offset(@offset).limit(@limit).all.reverse                                                                                         
        else
          limit = @user_count % @limit
          if limit == 0
            limit = @limit
          end
          @users_statuses = scope.offset(@offset).limit(limit).all.reverse
        end
        @s_type = 0
        # @projects = @projects.sort {|x,y| y.created_on <=> x.created_on }
        # @projects = @projects[@offset, @limit]
      when '1'
        @offset ||= @user_pages.reverse_offset
        unless @offset == 0
          @users_statuses = scope.reorder('grade').offset(@offset).limit(@limit).all.reverse
        else
          limit = @user_count % @limit
          if limit == 0
            limit = @limit
          end
          @users_statuses = scope.reorder('grade').offset(@offset).limit(limit).all.reverse
        end
        @s_type = 1
        #sort {|x,y| y.user_status.changesets_count <=> x.user_status.changesets_count}
        #@users = @users[@offset, @limit] 
      when '2'
        @offset ||= @user_pages.reverse_offset
        unless @offset == 0
          @users_statuses = scope.reorder('watchers_count').offset(@offset).limit(@limit).all.reverse
        else
          limit = @user_count % @limit
          if limit == 0
            limit = @limit
          end
          @users_statuses = scope.reorder('watchers_count').offset(@offset).limit(limit).all.reverse
        end
        @s_type = 2
        #@users = @users[@offset, @limit]   
      end
      
    else
      @offset ||= @user_pages.reverse_offset
        unless @offset == 0
          @users_statuses = scope.reorder('grade').offset(@offset).limit(@limit).all.reverse
        else
          limit = @user_count % @limit
          if limit == 0
            limit = @limit
          end
          @users_statuses = scope.reorder('grade').offset(@offset).limit(limit).all.reverse
        end
        @s_type = 1
      # @projects = @projects.sort {|x,y| y.created_on <=> x.created_on }
      # @projects = @projects[@offset, @limit]
    end
    
    @users = []
    @users_statuses.each do |obj|
      @users << User.find_by_id("#{obj.user_id}")
    end
    
   
    respond_to do |format|
      format.html {
        @groups = Group.all.sort
        render :layout => @user_base_tag
      }
      format.api
    end
  end
  
  def search
    sort_init 'login', 'asc'
    sort_update %w(login firstname lastname mail admin created_on last_login_on)

    case params[:format]
    when 'xml', 'json'
      @offset, @limit = api_offset_and_limit({:limit => 15})
    else
    @limit = 15#per_page_option
    end

    @status = params[:status] || 1
    has = {
      "show_changesets" => true
    }
       scope = User.logged.status(@status)
       scope = scope.like(params[:name]) if params[:name].present?
       @user_count = scope.count
       @user_pages = Paginator.new @user_count, @limit, params['page']
       @user_base_tag = params[:id] ? 'base_users':'base'
       @offset ||= @user_pages.reverse_offset
        unless @offset == 0
          @users = scope.offset(@offset).limit(@limit).all.reverse
        else
          limit = @user_count % @limit
          if limit == 0
            limit = @limit
          end
          @users = scope.offset(@offset).limit(limit).all.reverse
        end
        
    respond_to do |format|
      format.html {
        @groups = Group.all.sort
        render :layout => @user_base_tag
      }
      format.api
    end
  end
  
  def show
    pre_count = 10 #limit
    case params[:type]
    when "1"
      if @user == User.current
      activity = Activity.where('user_id = ?', User.current.id).order('id desc')
      @activity_count = activity.count
      @activity_pages = Paginator.new @activity_count, pre_count, params['page']
      @activity = activity.offset(@activity_pages.offset).limit(@activity_pages.per_page).all
      @state = 1
      end
    when "2"
      message = []
      if @user == User.current    
        message = JournalsForMessage.reference_message(@user.id)
        message += Journal.reference_message(@user.id)    
      end
      @activity_count = message.size
      @info_pages = Paginator.new @activity_count, pre_count, params['page']
      messages = message.sort {|x,y| y.created_on <=> x.created_on }
      @message = messages[@info_pages.offset, @info_pages.per_page]
      @state = 2
    else
      where_condition = nil;
      # where_condition = "act_type <> 'JournalsForMessage'"
      if @user == User.current
        watcher = User.watched_by(@user)
        watcher.push(User.current)
        activity = Activity.where(where_condition).where('user_id in (?)', watcher).order('id desc') 
      else
        activity = Activity.where(where_condition).where('user_id = ?', @user.id).order('id desc') 
      end
      @activity_count = activity.count
      @activity_pages = Paginator.new @activity_count, pre_count, params['page']
      @activity = activity.offset(@activity_pages.offset).limit(@activity_pages.per_page).all
      @state = 0
    end
    
    if params[:user].present?
      
      user_temp = User.find_by_sql("select id from users where concat(lastname,firstname) like '%#{params[:user]}%' or lastname like '%#{params[:user]}%'")
      
      if user_temp.size > 1
        activity = Activity.where('user_id in (?)', user_temp).where('user_id in (?)', watcher).order('id desc') 
      elsif user_temp.size == 1
        activity = Activity.where('user_id = ?', user_temp).where('user_id in (?)', watcher).order('id desc') 
      else
        activity = Activity.where("1 = 0")
      end
      @offset, @limit = api_offset_and_limit({:limit => 10})
      @activity_count = activity.count 
      @activity_pages = Paginator.new @activity_count, @limit, params['page']
      @offset ||= @activity_pages.offset
      @activity = activity.offset(@offset).limit(@limit) 
      @state = 0
    end
    
    
#Modified by nie
    unless User.current.admin?
      if !@user.active? #|| (@user != User.current  && @memberships.empty? && events.empty?)
        # redirect_to home_path
        render_404
      return
      end
    end

    respond_to do |format|
      format.html
      format.api
    end
  end

  ##end  fq

  #### added by fq
  def info

    message = []
    if @user == User.current    
      message = JournalsForMessage.reference_message(@user.id)
      message += Journal.reference_message(@user.id)    
    end
    @offset, @limit = api_offset_and_limit({:limit => 10})
    @info_count = message.size
    @info_pages = Paginator.new @info_count, @limit, params['page']
    @offset ||= @info_pages.offset
    
    messages = message.sort {|x,y| y.created_on <=> x.created_on }
    
    @message = messages[@offset, @limit]

    unless User.current.admin?
      if !@user.active?
        render_404
      return
      end
    end

    respond_to do |format|
      format.html
      format.api
    end
  end
  #### end
  

  def new
    @user = User.new(:language => Setting.default_language, :mail_notification => Setting.default_notification_option)
    @auth_sources = AuthSource.all
    render :layout => "base"
  end

  def create
    @user = User.new(:language => Setting.default_language, :mail_notification => Setting.default_notification_option)
    @user.safe_attributes = params[:user]
    @user.admin = params[:user][:admin] || false
    @user.login = params[:user][:login]
    @user.password, @user.password_confirmation = params[:user][:password], params[:user][:password_confirmation] unless @user.auth_source_id

    if @user.save
      @user.pref.attributes = params[:pref]
      @user.pref[:no_self_notified] = (params[:no_self_notified] == '1')
      @user.pref.save
      @user.notified_project_ids = (@user.mail_notification == 'selected' ? params[:notified_project_ids] : [])

      Mailer.account_information(@user, params[:user][:password]).deliver if params[:send_information]

      respond_to do |format|
        format.html {
          flash[:notice] = l(:notice_user_successful_create, :id => view_context.link_to(@user.login, user_path(@user)))
          if params[:continue]
            redirect_to new_user_path
          else
            redirect_to edit_user_path(@user)
          end
        }
        format.api  { render :action => 'show', :status => :created, :location => user_url(@user) }
      end
    else
      @auth_sources = AuthSource.all
      # Clear password input
      @user.password = @user.password_confirmation = nil

      respond_to do |format|
        format.html { render :action => 'new' }
        format.api  { render_validation_errors(@user) }
      end
    end
  end

  def edit
    @auth_sources = AuthSource.all
    @membership ||= Member.new
  end
  
  def watch_projects
    @watch_projects = Project.joins(:watchers).where("project_type <>? and watchable_type = ? and user_id = ?", '1','Project', @user.id)
    @state = 1
    respond_to do |format|
      format.html {
        render :layout => 'base_users'
      }
      format.api
    end
  end

  def update
    @user.admin = params[:user][:admin] if params[:user][:admin]
    @user.login = params[:user][:login] if params[:user][:login]
    if params[:user][:password].present? && (@user.auth_source_id.nil? || params[:user][:auth_source_id].blank?)
      @user.password, @user.password_confirmation = params[:user][:password], params[:user][:password_confirmation]
    end
    @user.safe_attributes = params[:user]
    # Was the account actived ? (do it before User#save clears the change)
    was_activated = (@user.status_change == [User::STATUS_REGISTERED, User::STATUS_ACTIVE])
    # TODO: Similar to My#account
    @user.pref.attributes = params[:pref]
    @user.pref[:no_self_notified] = (params[:no_self_notified] == '1')

    if @user.save
      @user.pref.save
      @user.notified_project_ids = (@user.mail_notification == 'selected' ? params[:notified_project_ids] : [])

      if was_activated
        Mailer.account_activated(@user).deliver
      elsif @user.active? && params[:send_information] && !params[:user][:password].blank? && @user.auth_source_id.nil?
        Mailer.account_information(@user, params[:user][:password]).deliver
      end

      respond_to do |format|
        format.html {
          flash[:notice] = l(:notice_successful_update)
          redirect_to_referer_or edit_user_path(@user)
        }
        format.api  { render_api_ok }
      end
    else
      @auth_sources = AuthSource.all
      @membership ||= Member.new
      # Clear password input
      @user.password = @user.password_confirmation = nil

      respond_to do |format|
        format.html { render :action => :edit }
        format.api  { render_validation_errors(@user) }
      end
    end
  end

  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_back_or_default(users_path) }
      format.api  { render_api_ok }
    end
  end

  def edit_membership
    @membership = Member.edit_membership(params[:membership_id], params[:membership], @user)
    @membership.save
    respond_to do |format|
      format.html { redirect_to edit_user_path(@user, :tab => 'memberships') }
      format.js
    end
  end

  def destroy_membership
    @membership = Member.find(params[:membership_id])
    if @membership.deletable?
    @membership.destroy
    end
    respond_to do |format|
      format.html { redirect_to edit_user_path(@user, :tab => 'memberships') }
      format.js
    end
  end

  ################# added by william
  def tag_save
    @tags = params[:tag_for_save][:name]
    @obj_id = params[:tag_for_save][:object_id]
    @obj_flag = params[:tag_for_save][:object_flag]

    case @obj_flag
    when '1' then
      @obj = User.find_by_id(@obj_id)
    when '2' then
      @obj = Project.find_by_id(@obj_id)
    when '3' then
      @obj = Issue.find_by_id(@obj_id)
    when '4' then
      @obj = Bid.find_by_id(@obj_id)
    when '5' then
      @obj = Forum.find_by_id(@obj_id)
    when '6'
      @obj = Attachment.find_by_id(@obj_id)
    when '7' then
      @obj = Contest.find_by_id(@obj_id)
    else
    @obj = nil
    end
    unless @obj.nil?
      @obj.tag_list.add(@tags.split(","))
    else
    return
    end
    if @obj.save
    ## 执行成功的操作。
    else
    #捕获异常
    end
    respond_to do |format|
      format.html
      format.js
    end   
  end
  
  ###add by huang
  def user_watchlist  
  end
  ###add by huang
  def user_fanslist  

  end
  
  #william
  def update_extensions(user_extensions)
    user_extensions = params[:user_extensions]
    unless user_extensions.nil?
     user_extensions = UserExtensions.find_by_id(user_extensions.user_id)
     
     # user_extensions.
    end
  end

# added by bai
  def topic_score_index
    
  end
  
  def project_score_index
    
  end
  
  def activity_score_index
    
  end
  
  def influence_score_index
    
  end
  
  def score_index
    
  end
# end
 
  private

  def find_user
    if params[:id] == 'current'
      require_login || return
      @user = User.current
    else
      @user = User.find(params[:id])
    end
  rescue ActiveRecord::RecordNotFound
    render_404
  end

  def setting_layout(default_base='base_users')
    User.current.admin? ? 'base_admin' : default_base 
  end
end
